<template>
    <app-layout>
        <template #header><inertia-link href="/users">User</inertia-link>: {{ targetUser.name }}</template>
        <form-section @submitted="updateProfileInformation" class="mb-10">
            <template #title>
                Profile Information
            </template>

            <template #description>
                Update this account's profile information and email address.
            </template>

            <template #form>
                <!-- Profile Photo -->
                <div class="col-span-6 sm:col-span-4" v-if="$page.jetstream.managesProfilePhotos">
                    <!-- Profile Photo File Input -->
                    <input type="file" class="hidden"
                                ref="photo"
                                @change="updatePhotoPreview">

                    <x-label for="photo" value="Photo" />

                    <!-- Current Profile Photo -->
                    <div class="mt-2" v-show="! photoPreview">
                        <img :src="targetUser.profile_photo_url" alt="Current Profile Photo" class="rounded-full h-20 w-20 object-cover">
                    </div>

                    <!-- New Profile Photo Preview -->
                    <div class="mt-2" v-show="photoPreview">
                        <span class="block rounded-full w-20 h-20"
                            :style="'background-size: cover; background-repeat: no-repeat; background-position: center center; background-image: url(\'' + photoPreview + '\');'">
                        </span>
                    </div>

                    <secondary-button class="mt-2 mr-2" type="button" @click.native.prevent="selectNewPhoto">
                        Select A New Photo
                    </secondary-button>

                    <secondary-button type="button" class="mt-2" @click.native.prevent="deletePhoto" v-if="targetUser.profile_photo_path">
                        Remove Photo
                    </secondary-button>

                    <input-error :message="profileForm.error('photo')" class="mt-2" />
                </div>

                <!-- Name -->
                <div class="col-span-6 sm:col-span-4">
                    <x-label for="name" value="Name" />
                    <x-input id="name" type="text" class="mt-1 block w-full" v-model="profileForm.name" autocomplete="name" />
                    <input-error :message="profileForm.error('name')" class="mt-2" />
                </div>

                <!-- Email -->
                <div class="col-span-6 sm:col-span-4">
                    <x-label for="email" value="Email" />
                    <x-input id="email" type="email" class="mt-1 block w-full" v-model="profileForm.email" />
                    <input-error :message="profileForm.error('email')" class="mt-2" />
                </div>
            </template>

            <template #actions>
                <action-message :on="profileForm.recentlySuccessful" class="mr-3">
                    Saved.
                </action-message>

                <x-button :class="{ 'opacity-25': profileForm.processing }" :disabled="profileForm.processing">
                    Save
                </x-button>
            </template>
        </form-section>
        <form-section @submitted="updatePassword" class="mb-10">
            <template #title>
                Reset Password
            </template>

            <template #description>
                Reset this user's password. Remind them to use a long, random password to stay secure.
            </template>

            <template #form>
                <div class="col-span-6 sm:col-span-4">
                    <x-label for="password" value="New Password" />
                    <x-input id="password" type="password" class="mt-1 block w-full" v-model="passwordForm.password" autocomplete="new-password" />
                    <input-error :message="passwordForm.error('password')" class="mt-2" />
                </div>

                <div class="col-span-6 sm:col-span-4">
                    <x-label for="password_confirmation" value="Confirm Password" />
                    <x-input id="password_confirmation" type="password" class="mt-1 block w-full" v-model="passwordForm.password_confirmation" autocomplete="new-password" />
                    <input-error :message="passwordForm.error('password_confirmation')" class="mt-2" />
                </div>
            </template>

            <template #actions>
                <action-message :on="passwordForm.recentlySuccessful" class="mr-3">
                    Reset Password.
                </action-message>

                <x-button :class="{ 'opacity-25': passwordForm.processing }" :disabled="passwordForm.processing">
                    Reset
                </x-button>
            </template>
        </form-section>
        <action-section class="mb-10">
            <template #title>
                Two Factor Authentication
            </template>

            <template #description>
                Check status of 2FA for the user. Using it is more secure.
            </template>

            <template #content>
                <h3 class="text-lg font-medium text-green-900 dark:text-green-300" v-if="targetUser.two_factor_enabled">
                    User has enabled two factor authentication. You should only disable it if the user asks and you have verified them!
                </h3>

                <h3 class="text-lg font-medium text-red-900 dark:text-red-300" v-else>
                    User has not enabled two factor authentication. Only the user can enable 2FA.
                </h3>

                <div class="mt-5">
                    <div v-if="targetUser.two_factor_enabled">
                        <danger-button @click="disableTwoFactorAuthentication"
                                        :class="{ 'opacity-25': disabling }"
                                        :disabled="disabling2fa">
                            Disable
                        </danger-button>
                    </div>
                </div>
            </template>
        </action-section>
        <action-section class="mb-10">
            <template #title>
                Memberships
            </template>

            <template #description>
                Groups and Organizations
            </template>

            <template #content>
                <div class="grid grid-cols-2">
                    <div>
                        <h3 class="text-lg font-medium">Groups</h3>
                        <div class="block ml-2" v-for="group in targetUser.groups" :key="group.id">
                            <inertia-link :href="'/groups/' + group.id">{{ group.name }}</inertia-link>
                        </div>
                        <div v-if="targetUser.groups.length == 0" class="text-sm ml-2">
                            User is not in any groups.
                        </div>
                    </div>
                    <div class="md:border-l dark:border-gray-700 md:pl-4">
                        <h3 class="text-lg font-medium">Organizations</h3>
                        <div class="block ml-2" v-for="group in targetUser.organizations" :key="group.id">
                            <inertia-link :href="'/organizations/' + group.id">{{ group.name }}</inertia-link>
                        </div>
                        <div v-if="targetUser.organizations.length == 0" class="text-sm ml-2">
                            User is not in any organizations.
                        </div>
                    </div>
                </div>
                <!--h3 class="text-lg font-medium">Groups</h3-->
            </template>
        </action-section>
        <action-section class="mb-10">
            <template #title>
                Login Audit
            </template>

            <template #description>
                Sessions and login logs
            </template>

            <template #content>

            </template>
        </action-section>
        <action-section>
            <template #title>
                Delete Account
            </template>

            <template #description>
                Permanently delete this account.
            </template>

            <template #content>
                <div class="max-w-xl text-sm text-gray-600 dark:text-gray-400">
                    Once the account is deleted, all of its shows, files, and personal displays will be permanently deleted.
                    Please verify that the user wants this before you do it - unless they broke the terms of course.
                    Any displays that you joined that belong to an organization will remain.
                </div>

                <div class="mt-5">
                    <danger-button @click.native="confirmingUserDeletion = true">
                        Delete Account
                    </danger-button>
                </div>

                <!-- Delete Account Confirmation Modal -->
                <dialog-modal :show="confirmingUserDeletion" @close="confirmingUserDeletion = false">
                    <template #title>
                        Delete Account
                    </template>

                    Are you sure you want to delete {{ targetUser.name }}'s account? Once this account is deleted, all of its resources and data will be permanently deleted.

                    <template #footer>
                        <secondary-button @click.native="confirmingUserDeletion = false">
                            Nevermind
                        </secondary-button>

                        <danger-button class="ml-2" @click.native="deleteUser" :class="{ 'opacity-25': deletingUser }" :disabled="deletingUser">
                            Delete Account
                        </danger-button>
                    </template>
                </dialog-modal>
            </template>
        </action-section>
        <!-- TODO: Groups, Audit Info, Password Reset, 2FA Settings, Sessions, Delete -->
    </app-layout>
</template>


<script>
export default {
    props: {
        targetUser: Object,
    },
    data() {
        return {
            profileForm: this.$inertia.form({
                '_method': 'PUT',
                name: this.targetUser.name,
                email: this.targetUser.email,
                photo: null,
            }, {
                bag: 'updateProfileInprofileFormation',
                resetOnSuccess: false,
            }),
            photoPreview: null,
            passwordForm: this.$inertia.form({
                current_password: '',
                password: '',
                password_confirmation: '',
            }, {
                bag: 'updatePassword',
            }),
            disabling2fa: false,
            confirmingUserDeletion: false,
            deletingUser: false,
        }
    },
    methods: {
        updateProfileInformation() {
            if (this.$refs.photo) {
                this.profileForm.photo = this.$refs.photo.files[0]
            }

            this.profileForm.post('/users/' + this.targetUser.id + '/profile-information', {
                preserveScroll: true,
            });
        },
        selectNewPhoto() {
            this.$refs.photo.click();
        },
        updatePhotoPreview() {
            const reader = new FileReader();

            reader.onload = (e) => {
                this.photoPreview = e.target.result;
            };

            reader.readAsDataURL(this.$refs.photo.files[0]);
        },
        deletePhoto() {
            this.$inertia.delete('/users/' + this.targetUser.id + '/profile-photo', {
                preserveScroll: true,
            }).then(() => {
                this.photoPreview = null;
            });
        },
        updatePassword() {
            this.form.put('/users/' + this.targetUser.id + '/password', {
                preserveScroll: true
            }).then(() => {
                this.$refs.current_password.focus();
            });
        },
        disableTwoFactorAuthentication() {
            this.disabling = true

            this.$inertia.delete('/users/' + this.targetUser.id + '/two-factor-authentication', {
                preserveScroll: true,
            }).then(() => {
                this.disabling2fa = false;
            });
        },
        deleteUser() {
            this.deletingUser = true;
            this.$inertia.delete('/users/' + this.targetUser.id, {
                preserveScroll: true,
                success: response => {
                    this.confirmingUserDeletion = false;
                    this.deletingUser = false;
                }
            });
        },
    },
}
</script>
